/*-----------------------------------------------------------------------------
                     lR[ht@C̃I[v^N[Y
-----------------------------------------------------------------------------*/

PRIVATE tHandle				/* ߒl:t@Cnh(=s) */
  openMcodeFile( void )
{
                tErrcode	retcode;
                tHandle		fhandle;

	retcode = sysOpenBinary( &fhandle, McodeFilename );
        if ( retcode == SUCCESS )
        {
                return fhandle;			/*  */
        }
	sprintf( ErrorMessage, "M-code file(%s) not exist", McodeFilename );
        return -1;
}

PRIVATE void				/* ߒl: */
  closeMcodeFile(
                tHandle   fhandle		/* :t@Cnh */
    		  )
{
        sysClose( fhandle );
}

#if 0
PRIVATE void				/* ߒl:0= =s */
  rewindMcodeFile(
                tHandle   fhandle		/* :t@Cnh */
    		   )
{
                tErrcode  retcode;

        retcode = sysSeek( fhandle, 0L );	/* ʒu=0ɃV[N */
        if (retcode == SUCCESS )
        {
		return 0;
	}
	sprintf( ErrorMessage, "Can't seek M-code file" );
	return -1;
}
#endif


/*PAGE*/
/*-----------------------------------------------------------------------------
                          lR[he[u̓ǂݏo
-----------------------------------------------------------------------------*/

PRIVATE int				/* ߒl:^Cԍ =s */
  readMcodeInfoTable(
                tHandle         fhandle		/* :t@Cnh */
    		      )
{
	 static struct McodeInfoStruct McodeInfo;
                tErrcode	retcode;
		tLocation       infosize;
                tLocation    	newloc;
		int		verINmcode;

/*	printf( "enter readMcodeInfoTable(): openhandle=%d\n", fhandle );*/	/*TEST*/

	infosize = sizeof(struct McodeInfoStruct);
/*	printf( "    infosize=%d\n", infosize );*/	/*TEST*/
	retcode = sysSeekEnd( &newloc, fhandle, (0-infosize) );
	if ( retcode != SUCCESS )
	{
		sprintf( ErrorMessage, "Can't seek M-code file" );
		return -1;
	}
	
        retcode = sysReadFixedSize( fhandle, &McodeInfo, (size_t)infosize );
	if ( retcode != SUCCESS )
	{
                sprintf( ErrorMessage, "Can't read Mcode-info" );
		return -1;
	}
/*	printf( "    ok-1\n" );*/	/*TEST*/

	if ( McodeInfo.minfoMark1 != 'M' || McodeInfo.minfoMark2 != 'C' )
	{
		sprintf( ErrorMessage, "Illegal Mcode mark" );
		return -1;
	}
/*	printf( "    ok-2\n" );*/	/*TEST*/

	verINmcode = McodeInfo.minfoMark4>>4;
/*	printf( "    mindex.c: verINmcode=%d MajorVersion=%d\n", verINmcode, MajorVersion );*/ /*TEST*/
	if ( verINmcode != MajorVersion )
	{
		if ( verINmcode != 3 || MajorVersion != 8 )
		{
			sprintf( ErrorMessage, "Mcode's versions missmatch");
			return -1;
		}
	}
/*	printf( "    ok-3\n" );*/	/*TEST*/

	return McodeInfo.minfoRuntimeNo;
}


/*PAGE*/
/*-----------------------------------------------------------------------------
                            lR[ht@Č
-----------------------------------------------------------------------------*/

PRIVATE int				/* ߒl: */
  check_mcodefilename( void )
{
		char	 *s;
		int	  length;
		int	  cmpresult;

	/* Fgq͕KtĂԂł */

	length = strlen( McodeFilename );
	cmpresult = -1;			/* svɂĂ */

	if ( length > 4 )
	{
		s = &McodeFilename[length-4];
		cmpresult = strcmpNocase( s, ".mco" );  /*vȂ[*/
	}

	if ( cmpresult != 0 )
	{
		/* gq .mco łȂ */
		sprintf( ErrorMessage, "No Mcode-Filename specified" );
		return -1;
	}

	return 0;
}


PRIVATE int				/* ߒl: */
  decide_version_no( void )
{
                tHandle   fhandle;
		int	  runtimeNo;

	fhandle = openMcodeFile();
	if ( fhandle < 0 )
	{
	    sprintf( ErrorMessage,"Can't open Mcode file(%s)",McodeFilename );
	    goto _error;
	}

	runtimeNo = readMcodeInfoTable( fhandle );
	if ( runtimeNo < 0 )
	{
/*	    printf( "errmsg=%s\n",ErrorMessage );*/ /*TEST*/
	    sprintf( ErrorMessage,"Can't read Mcode file(%s): errmsg=%s",McodeFilename,ErrorMessage );
	    goto _error;
	}
	if ( runtimeNo == 0 )
	{
	    sprintf( ErrorMessage,"Very old Mcode file(%s)", McodeFilename );
	    goto _error;
	}

	sprintf( VersionDigits, "%03d", runtimeNo );

	closeMcodeFile( fhandle );
	return 0;

_error:
	return -1;
}


/* end(mindex_readmcode.c) */
