/*----------------------------------------------------------------------------
                           sysGetLastErrorString
-----------------------------------------------------------------------------*/

PUBLIC  char *
sysGetLastErrorString( void )
{
	LPVOID lpMsgBuf;
 
	FormatMessage( 
		FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM,
		NULL,
		GetLastError(),
		MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // Default language
		(LPTSTR) &lpMsgBuf,
		0,
		NULL 
		    );

	return (char *)lpMsgBuf;
}

PUBLIC  char *
sysGetErrorString( DWORD errorNo )
{
	LPVOID lpMsgBuf;
 
	FormatMessage( 
		FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM,
		NULL,
		errorNo,
		MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // Default language
		(LPTSTR) &lpMsgBuf,
		0,
		NULL 
		    );

	return (char *)lpMsgBuf;
}

PUBLIC  void
sysFreeErrorString( void *string )
{
	LocalFree( string );
}


/*PAGE*/
/*----------------------------------------------------------------------------
                            sysRead(FixedSize)Ex()
----------------------------------------------------------------------------*/

PUBLIC  tErrcode			/* ߒl:G[R[h(0Ő) */
    sysReadEx(
		DWORD	  *resultBytes,	     /* 1:уoCgi[|C^ */
                HANDLE	  filehandle,	     /* 2:t@Cnh   */
                void      *buffer,           /* 3:obt@AhX   */
                DWORD	  requestBytes       /* 4:voCg       */
	     )
{
                int	  retcode;
		int	  errorNo;

	retcode = ReadFile(
			filehandle,
			buffer,
			requestBytes,
			resultBytes,
			NULL );		/* overlapped structure */

        if ( retcode != TRUE )
        {
		/* G[ */
		errorNo = GetLastError();
        }
        else
        {
		/*  */
		errorNo = 0;
        }

        return errorNo;
}


                       /* sysReadFixedSizeEx() */

PUBLIC  tErrcode                    /* ߒl:G[R[h(0Ő) */
    sysReadFixedSizeEx(
                HANDLE	  filehandle,	     /* 1:t@Cnh   */
                void      *buffer,           /* 2:obt@AhX   */
                DWORD	  requestBytes       /* 3:voCg       */
                      )
{
		DWORD	  resultBytes;
		int	  errorNo;

	errorNo = sysReadEx( &resultBytes, filehandle, buffer, requestBytes );

        if ( errorNo == 0 )
	{
                /* OSt@NVR[͐탊^[ */
                /* voCg𖞑Ă邩     */
                if ( resultBytes != requestBytes )
		{
                        /* voCgANZXł */
                        errorNo = ERROR_HANDLE_EOF;
		}
	}
        return errorNo;
}

/*PAGE*/
/*----------------------------------------------------------------------------
                            sysReadBlockEx()
----------------------------------------------------------------------------*/

PUBLIC  tErrcode                    /* ߒl:G[R[h(0Ő) */
    sysReadBlockEx(
		DWORD	  *resultBytes,	     /* 1:уoCgi[|C^ */
                HANDLE	  filehandle,	     /* 2:t@Cnh   */
                void      *buffer,           /* 3:obt@AhX   */
                DWORD	  bufferSize         /* 4:obt@TCY     */
                  )
{
		unsigned short blockLen;
		int	  errorNo;

	errorNo = sysReadFixedSizeEx( filehandle, &blockLen, 2 );
        if ( errorNo != 0 )
	{
		return errorNo;
	}

	if ( blockLen > bufferSize )
	{
		return ERROR_BUFFER_OVERFLOW;
	}

	errorNo = sysReadFixedSizeEx( filehandle, buffer, blockLen );
        if ( errorNo != 0 )
	{
		return errorNo;
	}

	*resultBytes = blockLen;

        return 0;
}


/*PAGE*/
/*----------------------------------------------------------------------------
                               sysWriteEx()
----------------------------------------------------------------------------*/

PUBLIC  tErrcode			/* ߒl:G[R[h(0Ő) */
    sysWriteEx(
                HANDLE	  filehandle,	     /* 1:t@Cnh   */
                void      *buffer,           /* 2:obt@AhX   */
                DWORD	  requestBytes       /* 3:voCg       */
              )
{
		DWORD	  resultBytes;
                int	  retcode;
		int	  errorNo;

	retcode = WriteFile(
			filehandle,
			buffer,
			requestBytes,
			&resultBytes,
			NULL );		/* overlapped structure */

        if ( retcode != TRUE )
        {
		/* G[ */
                errorNo = GetLastError();
        }
        else
        {
		/*  */
		if ( resultBytes == requestBytes )
		{
	                errorNo = 0;
		}
		else
		{
                        errorNo = ERROR_DISK_FULL;
		}
        }

        return errorNo;
}

/*PAGE*/
/*----------------------------------------------------------------------------
                             sysWriteBlockEx()
----------------------------------------------------------------------------*/

PUBLIC  tErrcode			/* ߒl:G[R[h(0Ő) */
    sysWriteBlockEx(
                HANDLE	  filehandle,	     /* 1:t@Cnh   */
                void      *buffer,           /* 2:obt@AhX   */
                DWORD	  requestBytes       /* 3:voCg       */
		   )
{
		unsigned short blockLen;
		DWORD	  resultBytes;
                int	  retcode;
		int	  errorNo;

	blockLen = requestBytes;

	errorNo = sysWriteEx( filehandle, &blockLen, 2 );
        if ( errorNo != 0 )
	{
		return errorNo;
	}

	errorNo = sysWriteEx( filehandle, buffer, blockLen );
        if ( errorNo != 0 )
	{
		return errorNo;
	}

        return 0;
}

/*PAGE*/
/*----------------------------------------------------------------------------
                     y    yMindP`z    z
  --------------------------------------------------------------------------*/

/*;GLOBAL*/

PRIVATE  void
  c_getErrorStringEx( void )		/* ;WORD c_getErrorStringEx */
{
	/* (errorNo  string(ASCIZ)) */

		int	errorNo;
		char	*message;

	errorNo = POP_L_OF_Q;

	message = sysGetErrorString( errorNo );

	PUSH_S( message, 0 );
}

PRIVATE  void
  c_freeErrorStringEx( void )		/* ;WORD c_freeErrorStringEx */
{
	/* (string(ASCIZ)  .) */

		char	*message;

	message = (char *)POP_A_OF_S;

	sysFreeErrorString( message );
}


/*----------------------------------------------------------------------------
                            c_readFileEx(pCvp)
----------------------------------------------------------------------------*/

/*;GLOBAL*/

PRIVATE  void
  c_readFileEx( void )		/* ;WORD c_readFileEx */
{
	/* (blockinfo, handle  blockinfo, errorNo) */

                HANDLE   	 handle;
		size_t		 blockSize;
		char		*blockAddr;
		DWORD		 resultBytes;
                int		 errorNo;

	handle    = (void *)POP_U_OF_Q;
	blockSize = POP_C;
	blockAddr = (char *)POP_A;

	errorNo = sysReadEx( &resultBytes, handle, blockAddr, blockSize );

        PUSH_S( blockAddr, resultBytes );
        PUSH_Q( errorNo, 0 );
}

/*PAGE*/
/*----------------------------------------------------------------------------
                        readFileFixedSizeEx(pCvp)
----------------------------------------------------------------------------*/

/*;GLOBAL*/

PRIVATE  void
  c_readFixedSizeEx( void )		/* ;WORD c_readFixedSizeEx */
{
	/* (blockinfo, handle  blockinfo, errorNo) */

                HANDLE   	 handle;
		size_t		 blockSize;
		char		*blockAddr;
		DWORD		 resultBytes;
                int		 errorNo;

	handle    = (void *)POP_U_OF_Q;
	blockSize = POP_C;
	blockAddr = (char *)POP_A;

	errorNo = sysReadFixedSizeEx( handle, blockAddr, blockSize );

	PUSH_S( blockAddr, blockSize );
        PUSH_Q( errorNo, 0 );
}


/*----------------------------------------------------------------------------
                            readBlockEx(pCvp)
----------------------------------------------------------------------------*/

/*;GLOBAL*/

PRIVATE  void
  c_readBlockEx( void )		/* ;WORD c_readBlockEx */
{
	/* (bufferinfo, handle  blockinfo, errorNo) */

                HANDLE   	 handle;
		size_t		 bufferSize;
		char		*bufferAddr;
		DWORD		 resultBytes;
                int		 errorNo;

	handle    = (void *)POP_U_OF_Q;
	bufferSize = POP_C;
	bufferAddr = (char *)POP_A;

	errorNo = sysReadBlockEx( &resultBytes, handle,
				   bufferAddr, bufferSize );

	PUSH_S( bufferAddr, resultBytes );
        PUSH_Q( errorNo, 0 );
}

/*PAGE*/
/*----------------------------------------------------------------------------
                             writeFileEx(pCvp)
----------------------------------------------------------------------------*/

PRIVATE  void
  c_writeEx( void )		/* ;WORD c_writeEx */
{
	/* (blockinfo, handle  errorNo) */

                HANDLE   	 handle;
		size_t		 blockSize;
		char		*blockAddr;
		DWORD		 resultBytes;
		int	  	 errorNo;

	/* --------------------------------------------- */
	/* :voCg߂Ȃꍇɂ̓G */
	/*    [ƂȂ. ̓_͂b̎dlƂ͈Ⴄ.  */
	/* --------------------------------------------- */

	handle    = (void *)POP_U_OF_Q;
	blockSize = POP_C;
	blockAddr = (char *)POP_A;

	errorNo = sysWriteEx( handle, blockAddr, blockSize );

        PUSH_Q( errorNo, 0 );
}


/*----------------------------------------------------------------------------
                           writeBlockEx(pCvp)
----------------------------------------------------------------------------*/

PRIVATE  void
  c_writeBlockEx( void )		/* ;WORD c_writeBlockEx */
{
	/* (blockinfo, handle  errorNo) */

                HANDLE   	 handle;
		size_t		 blockSize;
		char		*blockAddr;
		DWORD		 resultBytes;
		int	  	 errorNo;

	/* --------------------------------------------- */
	/* :voCg߂Ȃꍇɂ̓G */
	/*    [ƂȂ. ̓_͂b̎dlƂ͈Ⴄ.  */
	/* --------------------------------------------- */

	handle    = (void *)POP_U_OF_Q;
	blockSize = POP_C;
	blockAddr = (char *)POP_A;

	errorNo = sysWriteBlockEx( handle, blockAddr, blockSize );

        PUSH_Q( errorNo, 0 );
}

/*PAGE*/
/*----------------------------------------------------------------------------
                                closeHandle()
----------------------------------------------------------------------------*/

/*;GLOBAL*/

PRIVATE  void
  c_closeHandle( void )		/* ;WORD c_closeHandle */
{
	/* (handle  errorNo) */

                HANDLE   	 handle;
                tErrcode     	 retcode;

	handle = (void *)POP_U_OF_Q;

	retcode = CloseHandle( handle );
        if ( retcode != TRUE )
        {       /* G[ */
                retcode = GetLastError();
        }
        else
        {	/*  */
                retcode = 0;
        }

        PUSH_Q( retcode, 0 );
}


/*PAGE*/
/*----------------------------------------------------------------------------
                               OpCv
----------------------------------------------------------------------------*/

PRIVATE int	lowSecurity = 0;

PRIVATE  void
  lowSecurityMode( void )		/* ;WORD ZLBeB[h */
{
	lowSecurity = 1;
}

PRIVATE  void
  hiSecurityMode( void )		/* ;WORD ZLBeB[h */
{
	lowSecurity = 0;
}

PRIVATE SECURITY_ATTRIBUTES *
  setupSecurity_Attribute_Descriptor(
		SECURITY_ATTRIBUTES *sa, SECURITY_DESCRIPTOR *sd
				    )
{
	sa->nLength = sizeof(SECURITY_ATTRIBUTES);
	sa->bInheritHandle = TRUE;

	if ( lowSecurity )
	{
	    /* ZLeBݒ */
	    // Initialize the new security descriptor.
	    InitializeSecurityDescriptor (sd, SECURITY_DESCRIPTOR_REVISION);
	    // Add a NULL descriptor ACL to the security descriptor.
	    SetSecurityDescriptorDacl (sd, TRUE, (PACL)NULL, FALSE);
	    sa->lpSecurityDescriptor = sd;
	    return sa;
	}
	else
	{
	    /* ZLeBiftHgjłNULLݒ */
	    return NULL;
	}
}

PRIVATE int /* errorNo */
  createAnonymousPipe( HANDLE *readP, HANDLE *writeP, int buffsize )
{
		DWORD	errorNo;
		SECURITY_ATTRIBUTES sa;
		SECURITY_DESCRIPTOR sd;
		SECURITY_ATTRIBUTES *sap;

	sap = setupSecurity_Attribute_Descriptor( &sa, &sd );
	errorNo = CreatePipe( readP, writeP, sap, buffsize );
	if ( errorNo != TRUE )
        {
		/* s */
                errorNo = GetLastError();
        }
        else
        {
		/*  */
                errorNo = 0;
        }
	return errorNo;
}

PRIVATE void
  c_createAnonymousPipe( void )	/* ;WORD c_createAnonymousPipe */
{
	/* (buffsize  writeHandle, readHandle, errorNo) */

		int	buffsize;
		HANDLE	readP;
		HANDLE	writeP;
		DWORD	errorNo;

	buffsize = POP_L_OF_Q;

	errorNo = createAnonymousPipe( &readP, &writeP, buffsize );

        PUSH_Q( writeP, 0 );		/* push writepCv */
	PUSH_Q( readP, 0 );		/* push readpCv  */
	PUSH_Q( errorNo , 0 );		/* push errno       */
}


/*PAGE*/
/*----------------------------------------------------------------------------
                             OtpCv
----------------------------------------------------------------------------*/

/*;GLOBAL*/

#if 0	   /* OtpCv̎iWin95/98ł͎gȂNTłOKj */
HANDLE CreateNamedPipe(
    LPCTSTR lpName,	// pointer to pipe name 
    DWORD dwOpenMode,	// pipe open mode 
    DWORD dwPipeMode,	// pipe-specific modes 
    DWORD nMaxInstances,	// maximum number of instances  
    DWORD nOutBufferSize,	// output buffer size, in bytes 
    DWORD nInBufferSize,	// input buffer size, in bytes 
    DWORD nDefaultTimeOut,	// time-out time, in milliseconds 
    LPSECURITY_ATTRIBUTES lpSecurityAttributes 	// pointer to secu
				rity attributes structure 
   );
#endif

#if 0		/* ͎gȂ */
PRIVATE void
    c_CreateNamedPipe( void )			/* ;WORD c_CreateNamedPipe */
{
	/* (Name  PipeHandle, errno) */

		char	       *Name;
		int		openMode;
		int		pipeMode;
		int		maxInstances;
		int		outBufferSize;
		int		inBufferSize;
		int		defaultTimeOut;
		SECURITY_ATTRIBUTES sa;
		SECURITY_DESCRIPTOR sd;
		SECURITY_ATTRIBUTES *sap;
		int		PipeHandle;
		int		errorNo;

	Name     = (char *)POP_A_OF_S;
	openMode = PIPE_ACCESS_DUPLEX | WRITE_OWNER;
	pipeMode = PIPE_TYPE_MESSAGE | PIPE_READMODE_MESSAGE | PIPE_WAIT;
	maxInstances   = 5;
	outBufferSize  = 1024;
	inBufferSize   = 1024;
	defaultTimeOut = 1000 * 10;	/* 10 Secconds */
	sap = setupSecurity_Attribute_Descriptor( &sa, &sd );

	PipeHandle = CreateNamedPipe(
			Name,
			openMode,
			pipeMode,
			maxInstances,
			outBufferSize,
			inBufferSize,
			defaultTimeOut,
			sap );			/* security attribute */

	/*printf("PipeHandle=%d\n",PipeHandle);*/	/*TEST*/
	if ( PipeHandle != INVALID_HANDLE_VALUE )
	{
		/*  */
		PUSH_Q( PipeHandle, 0 );	/* Handle */
		PUSH_Q( 0, 0 );			/* ErrorCode=0 */
	}
	else
	{
		/* s */
       	        errorNo = GetLastError();
		PUSH_Q( 0, 0 );			/* Handle=0 */
		PUSH_Q( errorNo, 0 );		/* ErrorCode */
	}
}
#endif


/*PAGE*/
/*----------------------------------------------------------------------------
                              CreateProcess()
----------------------------------------------------------------------------*/

/*;GLOBAL*/

#if 0
BOOL CreateProcess(
    LPCTSTR lpApplicationName,	// pointer to name of executable module 
    LPTSTR lpCommandLine,	// pointer to command line string
    LPSECURITY_ATTRIBUTES lpProcessAttributes,	// pointer to process securit 
    LPSECURITY_ATTRIBUTES lpThreadAttributes,	// pointer to thread security
    BOOL bInheritHandles,	// handle inheritance flag 
    DWORD dwCreationFlags,	// creation flags 
    LPVOID lpEnvironment,	// pointer to new environment block 
    LPCTSTR lpCurrentDirectory,	// pointer to current directory name 
    LPSTARTUPINFO lpStartupInfo,	// pointer to STARTUPINFO 
    LPPROCESS_INFORMATION lpProcessInformation 	// pointer to PROCESS_INFORMA
   );	

typedef struct _SECURITY_ATTRIBUTES { // sa  
    DWORD  nLength; 		//=\̂̃oCg
    LPVOID lpSecurityDescriptor;//=NULL
    BOOL   bInheritHandle; 	//=TRUE
} SECURITY_ATTRIBUTES; 

typedef struct _STARTUPINFO { // si
    /* S[NAĂcb̂ݐݒ肷̂ył */
    DWORD   cb; 		//=\̂̃oCg
    LPTSTR  lpReserved;		//=NULL
    LPTSTR  lpDesktop; 		//=NULL
    LPTSTR  lpTitle; 		//=NULL
    DWORD   dwX; 		//ݒsp
    DWORD   dwY; 		//ݒsp
    DWORD   dwXSize; 		//ݒsp
    DWORD   dwYSize; 		//ݒsp
    DWORD   dwXCountChars; 	//ݒsp
    DWORD   dwYCountChars; 	//ݒsp
    DWORD   dwFillAttribute; 	//ݒsp
    DWORD   dwFlags; 		//=0
    WORD    wShowWindow; 	//ݒsp
    WORD    cbReserved2; 	//=0
    LPBYTE  lpReserved2; 	//=NULL
    HANDLE  hStdInput; 		//ݒsp
    HANDLE  hStdOutput; 	//ݒsp
    HANDLE  hStdError;  	//ݒsp
} STARTUPINFO, *LPSTARTUPINFO; 

typedef struct _PROCESS_INFORMATION {
    /* ׂĎ󂯎f[^Ȃ̂Őݒspł */
    HANDLE hProcess;
    HANDLE hThread; 
    DWORD dwProcessId; 
    DWORD dwThreadId; 
} PROCESS_INFORMATION; 
#endif

/*PAGE*/

PRIVATE void
    c_CREATE_NEW_CONSOLE( void )	/* ;WORD CREATE_NEW_CONSOLE */
{
	/* (.  value) */
	PUSH_Q( CREATE_NEW_CONSOLE, 0 );
}

PRIVATE void
    c_DETACHED_PROCESS( void )		/* ;WORD DETACHED_PROCESS */
{
	/* (.  value) */
	/*----------------------------------*/
	/* R\[vZXɃR\[ */
	/* JȂ悤ɂƂw肷 */
	/*----------------------------------*/
	PUSH_Q( DETACHED_PROCESS, 0 );
}

PRIVATE void
    c_HIGH_PRIORITY_CLASS( void )	/* ;WORD HIGH_PRIORITY_CLASS */
{
	/* (.  value) */
	PUSH_Q( HIGH_PRIORITY_CLASS, 0 );
}

PRIVATE void
    c_IDLE_PRIORITY_CLASS( void )	/* ;WORD IDLE_PRIORITY_CLASS */
{
	/* (.  value) */
	PUSH_Q( IDLE_PRIORITY_CLASS, 0 );
}

PRIVATE void
    c_NORMAL_PRIORITY_CLASS( void )	/* ;WORD NORMAL_PRIORITY_CLASS */
{
	/* (.  value) */
	PUSH_Q( NORMAL_PRIORITY_CLASS, 0 );
}

PRIVATE void
    c_REALTIME_PRIORITY_CLASS( void )	/* ;WORD REALTIME_PRIORITY_CLASS */
{
	/* (.  value) */
	PUSH_Q( REALTIME_PRIORITY_CLASS, 0 );
}

/*PAGE*/

PRIVATE void
    c_CreateProcess( void )			/* ;WORD c_CreateProcess */
{
	/* (commandline, CreationFlags  ProcessHandle, processID, errno) */

		int		CreationFlags;
		char	       *commandline;
		int		retcode;
		int		errorNo;
		SECURITY_ATTRIBUTES sa;
		SECURITY_DESCRIPTOR sd;
		SECURITY_ATTRIBUTES *sap;
		STARTUPINFO	    startInfo;
		PROCESS_INFORMATION procInfo;

	CreationFlags = POP_L_OF_Q;
	commandline   = (char *)POP_A_OF_S;

	/* SECURITY_ATTRIBUTES\̏ */
	sap = setupSecurity_Attribute_Descriptor( &sa, &sd );

	/* STARTUPINFO\̏ */
	memset( &startInfo, 0, sizeof(startInfo) );
	startInfo.cb = sizeof(startInfo);

	/*printf("CreationFlags=%08lX (DETACHED_PROCESS=%08lX)\n", TEST*/
	/*	CreationFlags,       DETACHED_PROCESS);		   TEST*/

	/*N=TRUE */
	retcode = CreateProcess( NULL,		/* application name */
				 commandline,	/* command line */
				 sap,		/* process security attrib */
				 sap,		/* thread security attrib */
				 TRUE,		/* inherit flag */
				 CreationFlags, /* creation flags */
				 NULL,		/* new environment */
				 NULL,		/* current directory */
				 &startInfo,	/* STARTUPINFO */
				 &procInfo );	/* PROCESS_INFOMATION */

	if ( retcode == TRUE )
	{
		/* true */
		PUSH_Q( procInfo.hProcess,    0 );
		PUSH_Q( procInfo.dwProcessId, 0 );
		PUSH_Q( 0, 0 );
	}
	else
	{
		/* s */
                PUSH_Q( 0, 0 );		/* Process Handle */
                PUSH_Q( 0, 0 );		/* Process ID     */
       	        errorNo = GetLastError();
		PUSH_Q( errorNo, 0 );
	}
}


/*PAGE*/
/*----------------------------------------------------------------------------
                              CreateFile()
----------------------------------------------------------------------------*/

/*;GLOBAL*/

PRIVATE void
    c_CreateFile( void )		/* ;WORD c_CreateFile */
{
	/* (fileName, createw(^U)  hFile, errno) */

		char	       *fileName;
		int		createmode;
		int		disposition;
		HANDLE		hFile;
		int		errorNo;

	createmode = POP_U_OF_Q;
	fileName = (char *)POP_A_OF_S;

	if ( createmode )
	{
		disposition = OPEN_ALWAYS;
	}
	else
	{
		disposition = OPEN_EXISTING;
	}

	hFile = CreateFile(
			fileName,		    /* File Name */
			GENERIC_READ|GENERIC_WRITE, /* DesiredAccess */
			FILE_SHARE_READ|FILE_SHARE_WRITE,  /* Share */
			NULL,			    /* SecurityAttri */
			disposition,		    /* Disposition */
			FILE_ATTRIBUTE_NORMAL,      /* FlagsAndAttr */
			NULL );			    /* TemplateFile */

	/*printf("hFile=%d\n",hFile);*/		/*TEST*/
	if ( hFile != INVALID_HANDLE_VALUE )
	{
		/*  */
		PUSH_Q( hFile, 0 );		/* Handle */
		PUSH_Q( 0, 0 );			/* ErrorCode=0 */
	}
	else
	{
		/* s */
       	        errorNo = GetLastError();
		PUSH_Q( 0, 0 );			/* Handle=0 */
		PUSH_Q( errorNo, 0 );		/* ErrorCode */
	}
}


/*PAGE*/
/*----------------------------------------------------------------------------
                          Create/OpenFileMapping()
----------------------------------------------------------------------------*/

PRIVATE void
    c_CreateFileMapping( void )		/* ;WORD c_CreateFileMapping */
{
	/* (hFile, filesize, objectName,   hMap, errno) */

	/* ------------------------------------------------- */
	/* FɃIuWFNg݂Ăꍇɂ́A      */
	/*     errno=ERROR_ALREADY_EXISTSłBǂ  */
	/*     l邩̓AvɂiAG[ɂjB*/
	/* ------------------------------------------------- */
		HANDLE		hFile;
		ULONG		fileSize;
		char	       *objectName;
		HANDLE		hMap;
		int		errorNo;
		SECURITY_ATTRIBUTES sa;
		SECURITY_DESCRIPTOR sd;
		SECURITY_ATTRIBUTES *sap;

	objectName = (char *)POP_A_OF_S;
	fileSize = POP_L_OF_Q;
	hFile = (HANDLE)POP_U_OF_Q;

	/*printf("Entry's hFile=%08lX,fileSize=%d,objectName=%s\n",*/ /*TEST*/
	/*		hFile,	    fileSize,   objectName);*/	      /*TEST*/

	sap = setupSecurity_Attribute_Descriptor( &sa, &sd );

	hMap = CreateFileMapping(
				hFile,		    /* file handle */
				sap, 		    /* security attributes */
			/*	PAGE_WRITECOPY,	*/  /* Protect */
				PAGE_READWRITE,	    /* Protect */
				0, fileSize,	    /* fileSize */
				objectName );	    /* Object Name */

	/*printf("hMap=%d\n",hMap);*/		/*TEST*/
	if ( hMap != NULL )
	{
		/*  */
       	        errorNo = GetLastError();
		if ( errorNo == ERROR_ALREADY_EXISTS )
		{
			/* ɏoĂ̂͂܂̂ŃG[ɂ */
			CloseHandle( hMap );		/* N[Y */
			PUSH_Q( 0, 0 );			/* Handle=0 */
			PUSH_Q( errorNo, 0 );		/* ErrorCode */
		}
		else
		{
			/*  */
			PUSH_Q( hMap, 0 );		/* Handle */
			PUSH_Q( 0, 0 );			/* ErrorCode=0 */
		}
	}
	else
	{
		/* s */
       	        errorNo = GetLastError();
		PUSH_Q( 0, 0 );			/* Handle=0 */
		PUSH_Q( errorNo, 0 );		/* ErrorCode */
	}
}


                        /* OpenFileMapping() */

PRIVATE void
    c_OpenFileMapping( void )		/* ;WORD c_OpenFileMapping */
{
	/* (objectName,   hMap, errno) */

		char	       *objectName;
		HANDLE		hMap;
		int		errorNo;

	objectName = (char *)POP_A_OF_S;

	hMap = OpenFileMapping(
		/*	FILE_MAP_COPY,	*/	/* Access mode */
			FILE_MAP_WRITE,		/* Access mode */
			FALSE,			/* Inherit */
			objectName );		/* object Name */

	/*printf("hMap=%d\n",hMap);*/		/*TEST*/
	if ( hMap != NULL )
	{
		/*  */
		PUSH_Q( hMap, 0 );		/* Handle */
		PUSH_Q( 0, 0 );			/* ErrorCode=0 */
	}
	else
	{
		/* s */
       	        errorNo = GetLastError();
		PUSH_Q( 0, 0 );			/* Handle=0 */
		PUSH_Q( errorNo, 0 );		/* ErrorCode */
	}
}

/*PAGE*/
/*----------------------------------------------------------------------------
                        MapViewOfFile()/UnmapViewOfFile()
----------------------------------------------------------------------------*/

PRIVATE void
    c_MapViewOfFile( void )		/* ;WORD c_MapViewOfFile */
{
	/* (hMap  memory, errno) */

		HANDLE		hMap;
		void		*memory;
		int		errorNo;

	hMap = (HANDLE)POP_U_OF_Q;

	memory = MapViewOfFile(
				hMap,			/* MapHandle */
			/*	FILE_MAP_COPY,	*/	/* DesiredAccess */
				FILE_MAP_WRITE,		/* DesiredAccess */
				0, 0, 			/* File Offset   */
				0 );			/* NumberOfBytes */

	/*printf("memory=%08lX\n",memory);*/		/*TEST*/
	if ( memory != NULL )
	{
		/*  */
		PUSH_Q( memory, 0 );		/* Memory Address */
		PUSH_Q( 0, 0 );			/* ErrorCode=0 */
	}
	else
	{
		/* s */
       	        errorNo = GetLastError();
		PUSH_Q( 0, 0 );			/* Handle=0 */
		PUSH_Q( errorNo, 0 );		/* ErrorCode */
	}
}

PRIVATE void
    c_UnmapViewOfFile( void )		/* ;WORD c_UnmapViewOfFile */
{
	/* (memory  errno) */

		void	*memory;
		int	retcode;
		int	errorNo;

	memory = (void *)POP_U_OF_Q;

	retcode = UnmapViewOfFile( memory );

	if ( retcode == TRUE )
	{
		/*  */
		PUSH_Q( 0, 0 );			/* ErrorCode=0 */
	}
	else
	{
		/* s */
       	        errorNo = GetLastError();
		PUSH_Q( errorNo, 0 );		/* ErrorCode */
	}
}


/*PAGE*/
/*----------------------------------------------------------------------------
                            Create/OpenEvent()
----------------------------------------------------------------------------*/

PRIVATE void
    c_CreateEvent( void )		/* ;WORD c_CreateEvent */
{
	/* (objectName,   hEvent, errorNo) */

	/* ------------------------------------------------- */
	/* FɃIuWFNg݂Ăꍇɂ́A      */
	/*     errno=ERROR_ALREADY_EXISTSłBǂ  */
	/*     l邩̓AvɂiAG[ɂjB*/
	/* ------------------------------------------------- */
		char	       *objectName;
		HANDLE		hEvent;
		int		errorNo;
		SECURITY_ATTRIBUTES sa;
		SECURITY_DESCRIPTOR sd;
		SECURITY_ATTRIBUTES *sap;

	objectName = (char *)POP_A_OF_S;

	sap = setupSecurity_Attribute_Descriptor( &sa, &sd );

	hEvent = CreateEvent( sap,		/* security attribute */
			      FALSE,		/* flag for manual-reset */
			      FALSE,		/* flag initial state */
			      objectName );	/* object name */

	if ( hEvent != NULL )
	{
       	        errorNo = GetLastError();
		if ( errorNo == ERROR_ALREADY_EXISTS )
		{
			/* ɏoĂ̂͂܂̂ŃG[ɂ */
			CloseHandle( hEvent );		/* N[Y */
			PUSH_Q( 0, 0 );			/* Handle=0 */
			PUSH_Q( errorNo, 0 );		/* ErrorCode */
		}
		else
		{
			/*  */
			PUSH_Q( hEvent, 0 );		/* Handle */
			PUSH_Q( 0, 0 );			/* ErrorCode=0 */
		}
	}
	else
	{
		/* s */
       	        errorNo = GetLastError();
		PUSH_Q( 0, 0 );			/* Handle=0 */
		PUSH_Q( errorNo, 0 );		/* ErrorCode */
	}
}


PRIVATE void
    c_CreateAnonymousEvent( void )	/* ;WORD c_CreateAnonymousEvent */
{
	/* (.  hEvent, errorNo) */

		HANDLE		hEvent;
		int		errorNo;
		SECURITY_ATTRIBUTES sa;
		SECURITY_DESCRIPTOR sd;
		SECURITY_ATTRIBUTES *sap;

	sap = setupSecurity_Attribute_Descriptor( &sa, &sd );

	hEvent = CreateEvent( sap,		/* security attributes */
			      FALSE,		/* flag for manual-reset */
			      FALSE,		/* flag initial state */
			      NULL );		/* Object name */

	if ( hEvent != NULL )
	{
       	        errorNo = GetLastError();
		if ( errorNo == ERROR_ALREADY_EXISTS )
		{
			/* ɏoĂ̂͂܂̂ŃG[ɂ */
			CloseHandle( hEvent );		/* N[Y */
			PUSH_Q( 0, 0 );			/* Handle=0 */
			PUSH_Q( errorNo, 0 );		/* ErrorCode */
		}
		else
		{
			/*  */
			PUSH_Q( hEvent, 0 );		/* Handle */
			PUSH_Q( 0, 0 );			/* ErrorCode=0 */
		}
	}
	else
	{
		/* s */
       	        errorNo = GetLastError();
		PUSH_Q( 0, 0 );			/* Handle=0 */
		PUSH_Q( errorNo, 0 );		/* ErrorCode */
	}
}


                            /* OpenEvent() */

PRIVATE void
    c_OpenEvent( void )		/* ;WORD c_OpenEvent */
{
	/* (objectName,   hEvent, errorNo) */

		char	       *objectName;
		HANDLE		hEvent;
		int		errorNo;

	objectName = (char *)POP_A_OF_S;

	hEvent = OpenEvent( EVENT_ALL_ACCESS,	/* access flag */
			    FALSE,		/* inherit flag */
			    objectName );	/* object name */

	/*printf("hEvent=%d\n",hEvent);*/		/*TEST*/
	if ( hEvent != NULL )
	{
		/*  */
		PUSH_Q( hEvent, 0 );		/* Handle */
		PUSH_Q( 0, 0 );			/* ErrorCode=0 */
	}
	else
	{
		/* s */
       	        errorNo = GetLastError();
		PUSH_Q( 0, 0 );			/* Handle=0 */
		PUSH_Q( errorNo, 0 );		/* ErrorCode */
	}
}

/*PAGE*/
/*----------------------------------------------------------------------------
                               SetEvent()
----------------------------------------------------------------------------*/

PRIVATE void
    c_SetEvent( void )		/* ;WORD c_SetEvent */
{
	/* (hEvent   errorNo) */

		HANDLE		hEvent;
		int		result;
		int		errorNo;

	hEvent = (HANDLE)POP_U_OF_Q;

	result = SetEvent( hEvent );

	if ( result == TRUE )
	{
		/*  */
		PUSH_Q( 0, 0 );			/* ErrorCode=0 */
	}
	else
	{
		/* s */
       	        errorNo = GetLastError();
		PUSH_Q( errorNo, 0 );		/* ErrorCode */
	}
}

/*PAGE*/
/*----------------------------------------------------------------------------
                            Create/OpenMutex()
----------------------------------------------------------------------------*/

PRIVATE void
    c_CreateMutex( void )		/* ;WORD c_CreateMutex */
{
	/* (objectName,   hMutex, errorNo) */

	/* ------------------------------------------------- */
	/* FɃIuWFNg݂Ăꍇɂ́A      */
	/*     errno=ERROR_ALREADY_EXISTSłBǂ  */
	/*     l邩̓AvɂiAG[ɂjB*/
	/* ------------------------------------------------- */
		char	       *objectName;
		HANDLE		hMutex;
		int		errorNo;
		SECURITY_ATTRIBUTES sa;
		SECURITY_DESCRIPTOR sd;
		SECURITY_ATTRIBUTES *sap;

	objectName = (char *)POP_A_OF_S;

	sap = setupSecurity_Attribute_Descriptor( &sa, &sd );

	hMutex = CreateMutex( sap,		/* security attributes */
			      TRUE,		/* initial ownership */
			      objectName );	/* object name */

	if ( hMutex != NULL )
	{
		errorNo = GetLastError();
		if ( errorNo == ERROR_ALREADY_EXISTS )
		{
			/* ɏoĂ̂͂܂̂ŃG[ɂ */
			CloseHandle( hMutex );		/* N[Y */
			PUSH_Q( 0, 0 );			/* Handle=0 */
			PUSH_Q( errorNo, 0 );		/* ErrorCode */
		}
		else
		{
			/*  */
			PUSH_Q( hMutex, 0 );		/* Handle */
			PUSH_Q( 0, 0 );			/* ErrorCode=0 */
		}
	}
	else
	{
		/* s */
       	        errorNo = GetLastError();
		PUSH_Q( 0, 0 );			/* Handle=0 */
		PUSH_Q( errorNo, 0 );		/* ErrorCode */
	}
}


PRIVATE void
    c_CreateMutexForce( void )		/* ;WORD c_CreateMutexForce */
{
	/* (objectName,   hMutex, , errorNo) */

	/* ------------------------------------------------- */
	/* FɃIuWFNg݂Ăꍇɂ́A      */
	/*     errno=ERROR_ALREADY_EXISTSłBǂ  */
	/*     l邩̓AvɂiAG[ɂjB*/
	/* ------------------------------------------------- */
		char	       *objectName;
		HANDLE		hMutex;
		int		errorNo;
		SECURITY_ATTRIBUTES sa;
		SECURITY_DESCRIPTOR sd;
		SECURITY_ATTRIBUTES *sap;

	objectName = (char *)POP_A_OF_S;

	sap = setupSecurity_Attribute_Descriptor( &sa, &sd );

	hMutex = CreateMutex( sap,		/* security attributes */
			      TRUE,		/* initial ownership */
			      objectName );

	if ( hMutex != NULL )
	{
		errorNo = GetLastError();
		if ( errorNo == ERROR_ALREADY_EXISTS )
		{
			/* ɏoĂĂǂƂɂ */
			PUSH_Q( hMutex, 0 );		/* Handle */
			PUSH_Q( 1, 0 );			/* =1 */
			PUSH_Q( 0, 0 );			/* ErrorCode=0 */
		}
		else
		{
			/* Ƃɍꂽ */
			PUSH_Q( hMutex, 0 );		/* Handle */
			PUSH_Q( 0, 0 );			/* =0 */
			PUSH_Q( 0, 0 );			/* ErrorCode=0 */
		}
	}
	else
	{
		/* s */
       	        errorNo = GetLastError();
		PUSH_Q( 0, 0 );			/* Handle=0 */
		PUSH_Q( 0, 0 );			/* =0 */
		PUSH_Q( errorNo, 0 );		/* ErrorCode */
	}
}


                             /* OpenMutex() */

PRIVATE void
    c_OpenMutex( void )		/* ;WORD c_OpenMutex */
{
	/* (objectName,   hMutex, errorNo) */

		char	       *objectName;
		HANDLE		hMutex;
		int		errorNo;

	objectName = (char *)POP_A_OF_S;

	hMutex = OpenMutex( MUTEX_ALL_ACCESS,	/* access flag */
			    FALSE,		/* inherit flag */
			    objectName );	/* object name */

	/*printf("hMutex=%d\n",hMutex);*/	/*TEST*/
	if ( hMutex != NULL )
	{
		/*  */
		PUSH_Q( hMutex, 0 );		/* Handle */
		PUSH_Q( 0, 0 );			/* ErrorCode=0 */
	}
	else
	{
		/* s */
       	        errorNo = GetLastError();
		PUSH_Q( 0, 0 );			/* Handle=0 */
		PUSH_Q( errorNo, 0 );		/* ErrorCode */
	}
}

/*PAGE*/
/*----------------------------------------------------------------------------
                               ReleaseMutex()
----------------------------------------------------------------------------*/

PRIVATE void
    c_ReleaseMutex( void )		/* ;WORD c_ReleaseMutex */
{
	/* (hMutex   errorNo) */

		HANDLE		hMutex;
		int		result;
		int		errorNo;

	hMutex = (HANDLE)POP_U_OF_Q;

	result = ReleaseMutex( hMutex );

	if ( result == TRUE )
	{
		/*  */
		PUSH_Q( 0, 0 );			/* ErrorCode=0 */
	}
	else
	{
		/* s */
       	        errorNo = GetLastError();
		PUSH_Q( errorNo, 0 );		/* ErrorCode */
	}
}

/*PAGE*/
/*----------------------------------------------------------------------------
                         WaitForSingle/MultipleObject()
----------------------------------------------------------------------------*/

PRIVATE void
    c_WaitForSingleObject( void )	/* ;WORD c_WaitForSingleObject */
{
	/* (handle, milisecond   resut, errorNo) */

	/* -------------------------- */
	/* result:                    */
	/*      -1: IuWFNgj  */
	/*	 0: ^CAEg      */
	/*	 1: VOio    */
	/* -------------------------- */

		HANDLE		handle;
		int		milisecond;
		int		result;
		int		errorNo;

	milisecond = POP_L_OF_Q;
	handle = (HANDLE)POP_U_OF_Q;

	/* VOi܂ő҂ */
	result = WaitForSingleObject( handle, milisecond );

	switch( result )
	{
		case WAIT_FAILED:
	       	        errorNo = GetLastError();
			PUSH_Q( 0, 0 );			/* dummy result */
			PUSH_Q( errorNo, 0 );		/* errorNo */
			break;
		case WAIT_OBJECT_0:
			PUSH_Q( 1, 0 );			/* result */
			PUSH_Q( 0, 0 );			/* errorNo */
			break;
		case WAIT_ABANDONED_0:
			PUSH_Q( -1, 0 );		/* result */
			PUSH_Q( 0, 0 );			/* errorNo */
			break;
		case WAIT_TIMEOUT:
		default:
			PUSH_Q( 0, 0 );			/* result */
			PUSH_Q( 0, 0 );			/* errorNo */
			break;
	}
}


                         /* WaitForMultipleObject() */

PRIVATE void
    c_WaitForMultipleObject( void )	/* ;WORD c_WaitForMultipleObject */
{
	/* (handle1,handle2,handleN, HANDLES, milisecond  resut, errorNo) */

	/* -------------------------- */
	/* result:                    */
	/*      -N: IuWFNgjN */
	/*      ``                */
	/*      -2: IuWFNgj2 */
	/*      -1: IuWFNgj1 */
	/*	 0: ^CAEg      */
	/*	 1: VOio1   */
	/*	 2: VOio2   */
	/*      ``                */
	/*	 N: VOioN   */
	/* -------------------------- */

		#define  MAX_MULT_HANDLES  5
		HANDLE		handle[MAX_MULT_HANDLES];
		int		handles;
		int		milisecond;
		int		i;
		int		result;
		int		errorNo;

	milisecond = POP_L_OF_Q;
	handles = POP_L_OF_Q;

	for( i=(handles-1); i>=0; i-- )
	{
		if ( i > MAX_MULT_HANDLES )   /* őnhzĂ */
		{
			POP_U_OF_Q;			  /* ̂Ă */
		}
		else
		{
			handle[i] = (HANDLE)POP_U_OF_Q;	  /* zɊi[ */
		}
	}

	if ( handles > MAX_MULT_HANDLES )  /* őnhzĂ */
	{
		PUSH_Q( 0, 0 );				  /* dummy result */
		PUSH_Q( ERROR_TOO_MANY_MUXWAITERS, 0 );	  /* errorNo */
		return;
	}

	/* VOi܂ő҂ */
	result = WaitForMultipleObjects(
				handles,	/* number of handles */
				handle,		/* array address */
				0,		/* wait all */
				milisecond );	/* timeout */

	if ( result == WAIT_FAILED )
	{
		errorNo = GetLastError();
		PUSH_Q( 0, 0 );				/* dummy result */
		PUSH_Q( errorNo, 0 );			/* errorNo */
	}
	else
	if ( result >=  WAIT_OBJECT_0 &&
	     result <= (WAIT_OBJECT_0 + handles - 1) )
	{
		/* push 1, 2, .. N */
		PUSH_Q( (result-WAIT_OBJECT_0+1), 0 );	/* result */
		PUSH_Q( 0, 0 );				/* errorNo */
	}
	else
	if ( result >=  WAIT_ABANDONED_0 &&
	     result <= (WAIT_ABANDONED_0 + handles - 1) )
	{
		/* push -1, -2, .. -N */
		PUSH_Q( 0-(LONG)(result-WAIT_ABANDONED_0+1),0);	/* result */
		PUSH_Q( 0, 0 );					/* errorNo */
	}
	else
	{
		/* WAIT_TIMEOUT(̂͂..) */
		PUSH_Q( 0, 0 );				/* result */
		PUSH_Q( 0, 0 );				/* errorNo */
	}
}


PRIVATE void
    c_INFINITE( void )			/* ;WORD INFINITE */
{
	/* (.  value) */
	PUSH_Q( INFINITE, 0 );
}

PRIVATE void
    c_WAIT_OBJECT_0( void )		/* ;WORD WAIT_OBJECT_0 */
{
	/* (.  value) */
	PUSH_Q( WAIT_OBJECT_0, 0 );
}

PRIVATE void
    c_WAIT_ABANDONED_0( void )		/* ;WORD WAIT_ABANDONED_0 */
{
	/* (.  value) */
	PUSH_Q( WAIT_ABANDONED_0, 0 );
}

PRIVATE void
    c_WAIT_TIMEOUT( void )		/* ;WORD WAIT_TIMEOUT */
{
	/* (.  value) */
	PUSH_Q( WAIT_TIMEOUT, 0 );
}


/*PAGE*/

#if 0
================================================================
DWORD GetFileAttributes(
    LPCTSTR lpFileName 	// address of the name of a file or directory  
   );	

			Value	Meaning
FILE_ATTRIBUTE_ARCHIVE
	The file or directory is an archive file or directory. Applications
	use this flag to mark files for backup or removal.
FILE_ATTRIBUTE_COMPRESSED
	The file or directory is compressed. For a file, this means that all
	of the data in the file is compressed. For a directory, this means
	that compression is the default for newly created files and subdirec
	tories.
FILE_ATTRIBUTE_DIRECTORY
	The "file or directory" is a directory.
FILE_ATTRIBUTE_HIDDEN
	The file or directory is hidden. It is not included in an ordinary
	directory listing.
FILE_ATTRIBUTE_NORMAL
	The file or directory has no other attributes set. This attribute
	is valid only if used alone.
FILE_ATTRIBUTE_OFFLINE
	The data of the file is not immediately available. Indicates that
	the file data has been physically moved to offline storage.
FILE_ATTRIBUTE_READONLY
	The file or directory is read-only. Applications can read the file
	but cannot write to it or delete it. In the case of a directory,
	applications cannot delete it.
FILE_ATTRIBUTE_SYSTEM
	The file or directory is part of, or is used exclusively by, the
	operating system.
FILE_ATTRIBUTE_TEMPORARY
	The file is being used for temporary storage. File systems attempt
	to keep all of the data in memory for quicker access rather than
	flushing the data back to mass storage. A temporary file should be
	deleted by the application as soon as it is no longer needed.
 
Return Values
----------
If the function succeeds, the return value contains the attributes of the specified file or directory.
If the function fails, the return value is 0xFFFFFFFF. To get extended error information, call GetLastError. 
The attributes can be one or more of the following values: 


=================================================

BOOL SetFileAttributes(
    LPCTSTR lpFileName,	// address of filename 
    DWORD dwFileAttributes 	// address of attributes to set 
   );	

seikika_flag &= ~opflag;

Return Values
----------
If the function succeeds, the return value is TRUE.
If the function fails, the return value is FALSE. To get extended error information, call GetLastError. 

#endif

