static int
is_space( char c )
{
	return ( c <= 0x20 );
}

static int
is_nonspace( char c )
{
	return ( c > 0x20 );
}

static char *
skip_space( char *string )
{
	while( *string != 0 && is_space(*string) )
	{
		string++;
	}
	return string;
}

static char *
skip_nonspace( char *string )
{
	while( *string != 0 && is_nonspace(*string) )
	{
		string++;
	}
	return string;
}

#define WITH_DQUOTE 0
#define NO_DQUOTE   1

static void
setargv( int *argcPtr, char ***argvPtr, char *myname, char *cmdLine,
	 int no_dquote )
{
		int	argc;
		int	args;
		char	**argv;
		char	*foundPos;
		int	pass;
		int	length;
		char	*cmdLineEnd;
		char	*cmdLineOrg;
		char	*beginPos;
		int	allocSize;
		char	*mem;
		char	*token;
		int	skip1req;

	/* -------------------- */
	/* argv[0]: myname	*/
	/* argv[1]: arg1	*/
	/* argv[2]: arg2	*/
	/* ``			*/
	/* argv[N]: argN	*/
	/* argv[N+1]: NULL	*/
	/* -------------------- */

	args = 0;
	argc = 0;
	pass = 1;

	length = strlen( cmdLine );
	cmdLineEnd = cmdLine + length - 1;
	cmdLineOrg = cmdLine;

	for(;;)
	{
		/* 󔒕܂ŃXLbv */
		cmdLine = skip_space( cmdLine );

		/* XLbvɂsIĂ܂ */
		if ( *cmdLine == 0 )
		{
			/* g[N͖ */
			if ( pass == 1 )
			{
				cmdLine = cmdLineOrg;
				pass = 2;
				/*printf("args=%d\n",args);*/	/*TEST*/

				/* argvi|C^jz̈mۂ */
				allocSize = (1 + args + 1) * sizeof(char *);
				/*printf("allocSize=%d\n",allocSize);*//*TEST*/
				mem = (char *)malloc( allocSize );
				argv = (char **)mem;

				/* ŏ̃Gg(myname)L */
				length = strlen( myname );
				token = (char *)malloc( length + 1 );
				strcpy( token, myname );
				/*printf("Token=[%s]\n",token);*/  /*TEST*/
				argv[0] = token;
				argc = 1;
				continue;
			}
			else
			{
				break;
			}
		}

		/* g[NL */
		/*printf("Found nonspace=[%s]\n",cmdLine);*/	/*TEST*/
		beginPos = cmdLine;
		if ( pass == 1 )
		{
			args++;
		}

		/* _uNI[gǂ */
		skip1req = 0;
		if ( *cmdLine == '"' )
		{
			/* --------------------------------------------- */
			/* _uNI[gt̃g[N("܂Ŏ) */
			/* --------------------------------------------- */
			cmdLine++;		/* 擪"XLbv */
			if ( no_dquote )
			{
				beginPos++;
			}

			foundPos = strchr( cmdLine, '"' );
			if ( foundPos == NULL )
			{
				/* "iُ) */
				cmdLine = cmdLineEnd;
			}
			else
			{
				/* "Li) */
				if ( no_dquote )
				{
					/* _uNI[gO܂Ŏ */
					cmdLine = foundPos;
					skip1req = 1;
				}
				else
				{
					/* _uNI[g܂߂Ď */
					cmdLine = foundPos+1;
				}
			}
		}
		else
		{
			/* ---------------------------------------------- */
			/* _uNI[g̃g[N(̋󔒂܂Ŏ) */
			/* ---------------------------------------------- */
			cmdLine = skip_nonspace( cmdLine );
		}

		/* g[Ni[ */
		if ( pass == 2 )
		{
			length = cmdLine - beginPos;
			token = (char *)malloc( length + 1 );
			memcpy( (void *)token, (void *)beginPos, length );
			token[length] = 0;
			/*printf("Token=[%s]\n",token);*/	/*TEST*/
			argv[argc] = token;
			argc++;
		}

		/* _uNI[gXLbv */
		if ( skip1req )
		{
			cmdLine++;
		}
	}

	argv[argc] = NULL;
	*argcPtr = argc;
	*argvPtr = argv;
}
